*
*  SEQUNF.F
*  Routine to convert Microsoft sequential unformatted files to Lahey style.
*  See page 348 (Appendix C) of the v4.00 MS Fortran manual for record formats.
*
*	Version 1.0, 10 Mar 88	S. Wilbur
*
*
	option nremember			! keeps the beaucoup data on the stack

	program sequnf

	external iswhite, abort
	logical*1 iswhite

	integer*2 start, len, i, j
	character*32768 buf
	character*128 dosbuf
	character*64 infile, outfile
	character type*7, byte

	dosbuf = ' '
	call getcl( dosbuf )
	if (index( dosbuf, '?' ) .ne. 0)
 	1 stop 'Usage: sequnf [? | {<MS filename> [<LCS filename>]}]'

	if (dosbuf .ne. ' ') then		! if there's a command line
		infile = ' '
		outfile = ' '
		i = 2
    1		if (iswhite( dosbuf(i:i) )) then	! turf white space
			i = i+1
			goto 1
		endif
		j = 1
    2		if (.not. iswhite( dosbuf(i:i) )) then	! parse input filename
			infile(j:j) = dosbuf(i:i)
			i = i+1
			j = j+1
			goto 2
		endif
		if (dosbuf(i:) .ne. ' ') then		! if output filename was typed
			i = i+1					! seek it
    3			if (iswhite( dosbuf(i:i) )) then
				i = i+1
				goto 3
			endif
			outfile = dosbuf(i:)			! and get it
		else					! else prompt for it
			print, 'Please enter LCS output-filename: '
			input, outfile
		endif
	else					! else prompt for both filenames
		print, 'Please enter MS input-filename: '
		input, infile
		print, '   and the LCS output-filename: '
		input, outfile
	endif

*  now let Fortran check for existence/validity of files
	type = 'new'
	open( 11, infile, status='old', access='transparent', err=50 )
    5	open( 12, outfile, status=type, access='sequential',
 	1 form='unformatted', err=60 )

	read( 11 ) byte
	if (byte .ne. 'K') goto 70			! decimal 75 is MS BOF code

   10	start = 1
   20	read( 11 ) byte					! read forward length-byte
	len = ichar( byte )
	if (len .eq. 130) stop 'Conversion complete'	! decimal 130 is EOF code
	if (len .eq. 129) len = len - 1			! 129 indicates record continues
	read( 11 ) (buf(i:i), i = start, start+len-1)	! read data
	start = i					! point to next byte in buf
	read( 11 ) byte					! read trailer length-byte
	if (ichar( byte ) .eq. 129) goto 20		! loop until len < 129

	write( 12 ) (buf(i:i), i = 1, start-1)		! write in LCS format
	goto 10

   50	call abort( 'input file does not exist' )

   60	print, "Warning: '", outfile(1:nblank( outfile )),
 	1 "' already exists"
	print, "Overwrite (y/n): "
	input, byte
	if (byte .eq. 'y' .or. byte .eq. 'Y') then
		type = 'unknown'
		goto 5
	else
		call abort( 'output file already exists' )
	endif

   70	print, "Error: '", infile(1:nblank( infile )),
 	1 "' is not Microsoft sequential-unformatted"
	call exit( 4 )

	end
*****		Return TRUE if character is blank or tab (white space)
	logical*1 function iswhite( arg )
	character arg
	parameter (TAB=9)

	if (arg .eq. ' ' .or. arg .eq. char(TAB)) then
		iswhite = .TRUE.
	else
		iswhite = .FALSE.
	endif
	return
	end
*****		Scram routine
	subroutine abort( msg )
	character msg*(*)
	print, 'Error: ', msg
	call exit( 4 )
	end
