It is possible to reference a data area defined in an assembly-language
routine, in FORTRAN code.  The assembly routine is called with an
INTEGER argument, for example "MEMBLOCK".  The assembly routine stores 
the address of the data into "MEMBLOCK", then returns to FORTRAN code.  
The FORTRAN then calls a FORTRAN subroutine, passing CARG(MEMBLOCK) as 
an argument. The subroutine can then use that argument as a non-character 
scalar or array, and will be referencing the assembly data.

Assembly example:

	EXTRN	_GETML:FAR ;		Get memory
CODE	SEGMENT	PARA PUBLIC 'CODE'
	ASSUME	CS:CODE
	PUBLIC	TRICK

TRICK	PROC	FAR
	PUSH	BP
	MOV	BP,SP
	XOR	AX,AX;			Zero
	PUSH	AX
	MOV	AX,1000h;		1000 bytes
	PUSH	AX
	CALL	_GETML
	MOV	SP,BP;			Clean up stack
	LDS	SI,DWORD PTR [BP+6];	Pointer to first argument
	MOV	[SI],BX;		Offset
	MOV	[SI+2],AX;		Segment
	POP	BP
	RET
TRICK	ENDP
CODE	ENDS
	END

FORTRAN	Example:

	INTEGER MEMBLOCK
	CALL TRICK (MEMBLOCK)
	CALL USE_IT (CARG(MEMBLOCK))
	END
	SUBROUTINE USE_IT (IARRAY)
	INTEGER IARRAY (250)		! 1000 byte array
	DO 10 I = 1, 250
10	IARRAY(I) = I
	END
